> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-network/functions/clientfromnetwork.md).

# clientFromNetwork

Returns the client configuration from a `StacksNetwork` object, ensuring a fetch function is always present. If the network's `client.fetch` is not set, a default fetch function is created automatically.

***

### Usage

```ts
import { clientFromNetwork, STACKS_TESTNET } from '@stacks/network';

const client = clientFromNetwork(STACKS_TESTNET);

console.log(client.baseUrl); // 'https://api.testnet.hiro.so'
console.log(typeof client.fetch); // 'function' — always defined
```

#### Notes

* This is primarily used internally by `@stacks/transactions` networking functions to ensure a fetch function is always available.
* If `network.client.fetch` is already set, it is returned as-is.
* If not set, a new default fetch function is created via `createFetchFn()` from `@stacks/common`.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/network/src/network.ts#L107)

***

### Signature

```ts
function clientFromNetwork(network: StacksNetwork): Required<ClientOpts>;
```

***

### Returns

`Required<ClientOpts>`

An object with both `baseUrl` and `fetch` guaranteed to be defined:

```ts
{
  baseUrl: string;
  fetch: FetchFn;
}
```

***

### Parameters

#### network (required)

* **Type**: `StacksNetwork`

The network object to extract client configuration from.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-network/functions/clientfromnetwork.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
